The Canva Apps SDK, Connect APIs, and MCP are now unified in the Canva Developers SDK. Learn more⁠(opens in a new tab or window).
Canva Developers SDK
The Canva Apps SDK, Connect APIs, and MCP are now unified in the Canva Developers SDK. Learn more⁠(opens in a new tab or window).

Get design generation job

This API is currently provided as a preview. Be aware of the following:

  • There might be unannounced breaking changes.
  • Any breaking changes to preview APIs won't produce a new API version.
  • Public integrations that use preview APIs will not pass the review process, and can't be made available to all Canva users.

Gets the status and result of a design generation job created using the Create design generation job v2 API.

You might need to make multiple requests until the job has a success or failed status. For more information on the workflow for using asynchronous jobs, see API requests and responses.

Only the user and integration that created the job can retrieve it, and the user must be in the same team. Jobs expire 24 hours after creation.

Polling doesn't consume the user's AI credit allowance⁠(opens in a new tab or window). Reaching the AI allowance limit after job creation doesn't prevent retrieving the result.

Requires the design_generation capability.

HTTP method and URL path

GET https://api.canva.com/rest/v1/generations/{jobId}

This operation is rate limited to 120 requests per minute for each user of your app.

Authentication and authorization

This endpoint requires a valid access token that acts on behalf of a user.

Scopes

The access token must have all the following scopes (permissions):

  • design:content:write

Capabilities

The user must have at least one of the following capabilities:

  • design_generation

Header parameters

Authorizationstring
Required

Provides credentials to authenticate the request, in the form of a Bearer token.

For example: Authorization: Bearer {token}

Path parameters

jobIdstring
Required

The public design generation job ID.

Example request

Examples for using the /v1/generations/{jobId} endpoint:

curl --request GET 'https://api.canva.com/rest/v1/generations/{jobId}' \
--header 'Authorization: Bearer {token}'
SH
const fetch = require("node-fetch");
fetch("https://api.canva.com/rest/v1/generations/{jobId}", {
method: "GET",
headers: {
"Authorization": "Bearer {token}",
},
})
.then(async (response) => {
const data = await response.json();
console.log(data);
})
.catch(err => console.error(err));
JS
import java.io.IOException;
import java.net.URI;
import java.net.http.*;
public class ApiExample {
public static void main(String[] args) throws IOException, InterruptedException {
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://api.canva.com/rest/v1/generations/{jobId}"))
.header("Authorization", "Bearer {token}")
.method("GET", HttpRequest.BodyPublishers.noBody())
.build();
HttpResponse<String> response = HttpClient.newHttpClient().send(
request,
HttpResponse.BodyHandlers.ofString()
);
System.out.println(response.body());
}
}
JAVA
import requests
headers = {
"Authorization": "Bearer {token}"
}
response = requests.get("https://api.canva.com/rest/v1/generations/{jobId}",
headers=headers
)
print(response.json())
PY
using System.Net.Http;
var client = new HttpClient();
var request = new HttpRequestMessage
{
Method = HttpMethod.Get,
RequestUri = new Uri("https://api.canva.com/rest/v1/generations/{jobId}"),
Headers =
{
{ "Authorization", "Bearer {token}" },
},
};
using (var response = await client.SendAsync(request))
{
response.EnsureSuccessStatusCode();
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
};
CSHARP
package main
import (
"fmt"
"io"
"net/http"
)
func main() {
url := "https://api.canva.com/rest/v1/generations/{jobId}"
req, _ := http.NewRequest("GET", url, nil)
req.Header.Add("Authorization", "Bearer {token}")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
GO
$curl = curl_init();
curl_setopt_array($curl, array(
CURLOPT_URL => "https://api.canva.com/rest/v1/generations/{jobId}",
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array(
'Authorization: Bearer {token}',
),
));
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if (empty($err)) {
echo $response;
} else {
echo "Error: " . $err;
}
PHP
require 'net/http'
require 'uri'
url = URI('https://api.canva.com/rest/v1/generations/{jobId}')
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request['Authorization'] = 'Bearer {token}'
response = http.request(request)
puts response.read_body
RUBY

Success response

If successful, the endpoint returns a 200 response with a JSON body with the following parameters:

jobDesignGenerationJobV2

The status and result of a public design generation job.

idstring

The public design generation job ID.

statusstring

The public status of the job. result is present only for success, and error is present only for failed.

Available values:

  • failed: The design couldn't be generated.
  • in_progress: The design is still being generated.
  • success: The design was generated and saved to the user's Canva account.
resultDesignGenerationJobResultV2
Optional

Present only when the job status is success.

designDesignSummary

Basic details about the design, such as the design's ID, title, and URL.

idstring

The design ID.

urlsDesignLinks

A temporary set of URLs for viewing or editing the design.

edit_urlstring

A temporary editing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support return navigation workflows.

This is not a permanent URL, it is only valid for 30 days.

view_urlstring

A temporary viewing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support return navigation workflows.

This is not a permanent URL, it is only valid for 30 days.

created_atinteger

When the design was created in Canva, as a Unix timestamp (in seconds since the Unix Epoch).

updated_atinteger

When the design was last updated in Canva, as a Unix timestamp (in seconds since the Unix Epoch).

titlestring
Optional

The design title.

urlstring
Optional

URL of the design.

thumbnailThumbnail
Optional

A thumbnail image representing the object.

widthinteger

The width of the thumbnail image in pixels.

heightinteger

The height of the thumbnail image in pixels.

urlstring

A URL for retrieving the thumbnail image. This URL expires after 15 minutes. This URL includes a query string that's required for retrieving the thumbnail.

page_countinteger
Optional

The total number of pages in the design. Some design types don't have pages (for example, Canva docs).

errorDesignGenerationJobErrorV2
Optional

Details about a failed design generation job.

codestring

The reason the design generation job failed.

Available values:

  • content_not_allowed: The brief or generated content didn't pass Canva's content-safety checks.
  • generation_failed: Canva couldn't complete the design generation job.
messagestring

A human-readable description of what went wrong.

quota_usageobject
Optional

Credit quota snapshot when available. Polling does not reserve or consume credits; omitted if unavailable.

Example responses

In-progress design generation job

{
"job": {
"id": "f81b26fd-a33d-4c2d-9e8c-4a7aca798b17",
"status": "in_progress"
}
}
JSON

Successfully completed design generation job

{
"job": {
"id": "f81b26fd-a33d-4c2d-9e8c-4a7aca798b17",
"status": "success",
"result": {
"design": {
"id": "DAFVztcvd9z",
"title": "SolarNow Seed Pitch",
"urls": {
"edit_url": "https://www.canva.com/api/design/example/edit",
"view_url": "https://www.canva.com/api/design/example/view"
},
"thumbnail": {
"width": 800,
"height": 450,
"url": "https://document-export.canva.com/example/thumbnail/0001.png?signature=example"
},
"created_at": 1788768000,
"updated_at": 1788768000,
"page_count": 3
}
}
},
"quota_usage": {
"used_percentage": 25,
"resets_at": 1789257600,
"using_bonus_credits": false
}
}
JSON

Design generation rejected by content-safety checks

{
"job": {
"id": "f81b26fd-a33d-4c2d-9e8c-4a7aca798b17",
"status": "failed",
"error": {
"code": "content_not_allowed",
"message": "The design couldn't be generated because the request didn't meet Canva's content guidelines."
}
}
}
JSON

Design generation failed

{
"job": {
"id": "f81b26fd-a33d-4c2d-9e8c-4a7aca798b17",
"status": "failed",
"error": {
"code": "generation_failed",
"message": "The design couldn't be generated. Please try again."
}
}
}
JSON

Error responses

400 Bad Request

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error response

The job ID is invalid
{
"code": "invalid_field",
"message": "The design generation job ID is invalid."
}
JSON

401 Unauthorized

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error responses

The OAuth client credentials are invalid
{
"code": "invalid_client",
"message": "Client {clientId} not available"
}
JSON
Access token could not be decoded or signature could not be verified.
{
"code": "invalid_access_token",
"message": "Access token is invalid"
}
JSON
Client credentials or body auth are missing from the request
{
"code": "invalid_client",
"message": "Client credentials or body auth are missing from the request."
}
JSON
Authorization header has wrong number of components
{
"code": "invalid_access_token",
"message": "Malformed Authorization header: wrong number of components"
}
JSON
Authorization header has invalid mode
{
"code": "invalid_access_token",
"message": "Malformed Authorization header: invalid mode"
}
JSON
Token couldn't be introspected
{
"code": "invalid_access_token",
"message": "Token couldn't be introspected"
}
JSON
Access token is revoked
{
"code": "revoked_access_token",
"message": "Access token is revoked"
}
JSON
Missing Authorization header
{
"code": "invalid_access_token",
"message": "Missing Authorization header"
}
JSON
Malformed Authorization header
{
"code": "invalid_access_token",
"message": "Malformed Authorization header"
}
JSON

403 Forbidden

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error responses

Design generation isn't available to the user
{
"code": "permission_denied",
"message": "Design generation isn't available for this user."
}
JSON
The caller didn't create this job
{
"code": "permission_denied",
"message": "The user doesn't have access to this design generation job."
}
JSON

404 Not Found

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error response

The job wasn't found
{
"code": "not_found",
"message": "The design generation job wasn't found."
}
JSON

429 Too Many Requests

codestring

A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.

messagestring

A human-readable description of what went wrong.

Example error responses

Rate limit exceeded
{
"code": "too_many_requests",
"message": "Too many requests to {operation}"
}
JSON
Throttled because too many requests
{
"code": "too_many_requests",
"message": "Throttled because too many requests"
}
JSON

Try it out

This uses your live Canva data.

This is not a sandbox/playground. This form performs API requests against your account's actual live Canva data. Make sure that you understand what the request is doing, as well as the requirements for each parameter detailed above.

Step 1: Enter your access token

To get started, generate an access token or provide your own below